import{S as Ji,i as Yi,s as Qi,e as s,k as l,w as v,t as o,M as Xi,c as i,d as a,m as p,a as n,x,h as r,b as d,G as e,g as f,y as P,q as w,o as y,B as D,v as en,L as tn}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as St}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as Ki}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as Fe}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as an}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function sn(Et){let m,F,_,g,E;return g=new Ki({props:{code:`import requests
import torch

from diffusers import DDIMScheduler, StableDiffusionPix2PixZeroPipeline


def download(embedding_url, local_filepath):
    r = requests.get(embedding_url)
    with open(local_filepath, "wb") as f:
        f.write(r.content)


model_ckpt = "CompVis/stable-diffusion-v1-4"
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    model_ckpt, conditions_input_image=False, torch_dtype=torch.float16
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.to("cuda")

prompt = "a high resolution painting of a cat in the style of van gough"
source_emb_url = "https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/cat.pt"
target_emb_url = "https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/dog.pt"

for url in [source_emb_url, target_emb_url]:
    download(url, url.split("/")[-1])

src_embeds = torch.load(source_emb_url.split("/")[-1])
target_embeds = torch.load(target_emb_url.split("/")[-1])
images = pipeline(
    prompt,
    source_embeds=src_embeds,
    target_embeds=target_embeds,
    num_inference_steps=50,
    cross_attention_guidance_amount=0.15,
).images
images[0].save("edited_image_dog.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler, StableDiffusionPix2PixZeroPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download</span>(<span class="hljs-params">embedding_url, local_filepath</span>):
<span class="hljs-meta">... </span>    r = requests.get(embedding_url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">with</span> <span class="hljs-built_in">open</span>(local_filepath, <span class="hljs-string">&quot;wb&quot;</span>) <span class="hljs-keyword">as</span> f:
<span class="hljs-meta">... </span>        f.write(r.content)


<span class="hljs-meta">&gt;&gt;&gt; </span>model_ckpt = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
<span class="hljs-meta">... </span>    model_ckpt, conditions_input_image=<span class="hljs-literal">False</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;a high resolution painting of a cat in the style of van gough&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>source_emb_url = <span class="hljs-string">&quot;https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/cat.pt&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_emb_url = <span class="hljs-string">&quot;https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/dog.pt&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> url <span class="hljs-keyword">in</span> [source_emb_url, target_emb_url]:
<span class="hljs-meta">... </span>    download(url, url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>src_embeds = torch.load(source_emb_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_embeds = torch.load(target_emb_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipeline(
<span class="hljs-meta">... </span>    prompt,
<span class="hljs-meta">... </span>    source_embeds=src_embeds,
<span class="hljs-meta">... </span>    target_embeds=target_embeds,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    cross_attention_guidance_amount=<span class="hljs-number">0.15</span>,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;edited_image_dog.png&quot;</span>)`}}),{c(){m=s("p"),F=o("Examples:"),_=l(),v(g.$$.fragment)},l(u){m=i(u,"P",{});var k=n(m);F=r(k,"Examples:"),k.forEach(a),_=p(u),x(g.$$.fragment,u)},m(u,k){f(u,m,k),e(m,F),f(u,_,k),P(g,u,k),E=!0},p:tn,i(u){E||(w(g.$$.fragment,u),E=!0)},o(u){y(g.$$.fragment,u),E=!1},d(u){u&&a(m),u&&a(_),D(g,u)}}}function nn(Et){let m,F,_,g,E,u,k,Ge,ia,kt,q,G,Be,ee,na,He,oa,jt,te,ae,ra,la,Tt,we,pa,It,ye,We,da,qt,De,ca,Zt,j,$e,se,fa,ua,ha,Se,ie,ma,ga,_a,Ee,ne,ba,va,Ct,Z,B,Re,oe,xa,Ve,Pa,Lt,S,$,wa,Ke,ya,Da,Je,$a,Sa,Ye,Ea,ka,Qe,ja,Ta,Ia,C,qa,Xe,Za,Ca,et,La,Aa,Na,ke,Ma,re,L,za,tt,Oa,Ua,at,Fa,Ga,Ba,st,Ha,Wa,le,Ra,pe,Va,Ka,At,A,H,it,de,Ja,nt,Ya,Nt,W,ot,N,rt,Qa,Xa,lt,es,ts,je,as,ss,pt,M,dt,ce,is,ns,ct,ft,os,rs,Te,ls,Mt,z,R,ut,fe,ps,ht,ds,zt,Ie,mt,cs,Ot,ue,Ut,qe,gt,fs,Ft,Ze,_t,us,Gt,O,V,bt,he,hs,vt,ms,Bt,h,me,gs,xt,_s,bs,ge,vs,Ce,xs,Ps,ws,T,_e,ys,Pt,Ds,$s,K,Ss,J,be,Es,wt,ks,js,Y,ve,Ts,U,Is,yt,qs,Zs,Dt,Cs,Ls,As,Q,xe,Ns,$t,Ms,Ht;return u=new Fe({}),ee=new Fe({}),oe=new Fe({}),de=new Fe({}),fe=new Fe({}),ue=new Ki({props:{code:`import requests
import torch

from diffusers import DDIMScheduler, StableDiffusionPix2PixZeroPipeline


def download(embedding_url, local_filepath):
    r = requests.get(embedding_url)
    with open(local_filepath, "wb") as f:
        f.write(r.content)


model_ckpt = "CompVis/stable-diffusion-v1-4"
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    model_ckpt, conditions_input_image=False, torch_dtype=torch.float16
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.to("cuda")

prompt = "a high resolution painting of a cat in the style of van gough"
src_embs_url = "https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/cat.pt"
target_embs_url = "https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/dog.pt"

for url in [src_embs_url, target_embs_url]:
    download(url, url.split("/")[-1])

src_embeds = torch.load(src_embs_url.split("/")[-1])
target_embeds = torch.load(target_embs_url.split("/")[-1])

images = pipeline(
    prompt,
    source_embeds=src_embeds,
    target_embeds=target_embeds,
    num_inference_steps=50,
    cross_attention_guidance_amount=0.15,
).images
images[0].save("edited_image_dog.png")`,highlighted:`<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">import</span> torch

<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler, StableDiffusionPix2PixZeroPipeline


<span class="hljs-keyword">def</span> <span class="hljs-title function_">download</span>(<span class="hljs-params">embedding_url, local_filepath</span>):
    r = requests.get(embedding_url)
    <span class="hljs-keyword">with</span> <span class="hljs-built_in">open</span>(local_filepath, <span class="hljs-string">&quot;wb&quot;</span>) <span class="hljs-keyword">as</span> f:
        f.write(r.content)


model_ckpt = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    model_ckpt, conditions_input_image=<span class="hljs-literal">False</span>, torch_dtype=torch.float16
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a high resolution painting of a cat in the style of van gough&quot;</span>
src_embs_url = <span class="hljs-string">&quot;https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/cat.pt&quot;</span>
target_embs_url = <span class="hljs-string">&quot;https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/dog.pt&quot;</span>

<span class="hljs-keyword">for</span> url <span class="hljs-keyword">in</span> [src_embs_url, target_embs_url]:
    download(url, url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])

src_embeds = torch.load(src_embs_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])
target_embeds = torch.load(target_embs_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])

images = pipeline(
    prompt,
    source_embeds=src_embeds,
    target_embeds=target_embeds,
    num_inference_steps=<span class="hljs-number">50</span>,
    cross_attention_guidance_amount=<span class="hljs-number">0.15</span>,
).images
images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;edited_image_dog.png&quot;</span>)`}}),he=new Fe({}),me=new St({props:{name:"class diffusers.StableDiffusionPix2PixZeroPipeline",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddpm.DDPMScheduler, diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_euler_ancestral_discrete.EulerAncestralDiscreteScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler]"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"conditions_input_image",val:": bool = False"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/euler_ancestral#diffusers.EulerAncestralDiscreteScheduler">EulerAncestralDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/ddpm#diffusers.DDPMScheduler">DDPMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.conditions_input_image",description:`<strong>conditions_input_image</strong> (bool) &#x2014;
Whether to condition the pipeline with an input image to compute an inverted noise latent.`,name:"conditions_input_image"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.requires_safety_checker",description:`<strong>requires_safety_checker</strong> (bool) &#x2014;
Whether the pipeline requires a safety checker. We recommend setting it to True if you&#x2019;re using the
pipeline publicly.`,name:"requires_safety_checker"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L156"}}),_e=new St({props:{name:"__call__",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, NoneType] = None"},{name:"source_embeds",val:": Tensor = None"},{name:"target_embeds",val:": Tensor = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"cross_attention_guidance_amount",val:": float = 0.1"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>, <em>optional</em>) &#x2014;
<code>Image</code>, or tensor representing an image batch which will be used for conditioning.`,name:"image"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.source_embeds",description:`<strong>source_embeds</strong> (<code>torch.Tensor</code>) &#x2014;
Source concept embeddings. Generation of the embeddings as per the <a href="https://arxiv.org/abs/2302.03027" rel="nofollow">original
paper</a>. Used in discovering the edit direction.`,name:"source_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.target_embeds",description:`<strong>target_embeds</strong> (<code>torch.Tensor</code>) &#x2014;
Target concept embeddings. Generation of the embeddings as per the <a href="https://arxiv.org/abs/2302.03027" rel="nofollow">original
paper</a>. Used in discovering the edit direction.`,name:"target_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. If not defined, one has to pass <code>negative_prompt_embeds</code>. instead.
Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.cross_attention_guidance_amount",description:`<strong>cross_attention_guidance_amount</strong> (<code>float</code>, defaults to 0.1) &#x2014;
Amount of guidance needed from the reference cross-attention maps.`,name:"cross_attention_guidance_amount"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L559",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),K=new an({props:{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.example",$$slots:{default:[sn]},$$scope:{ctx:Et}}}),be=new St({props:{name:"construct_direction",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.construct_direction",parameters:[{name:"embs_source",val:": Tensor"},{name:"embs_target",val:": Tensor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L541"}}),ve=new St({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L250"}}),xe=new St({props:{name:"generate_caption",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.generate_caption",parameters:[{name:"image",val:""},{name:"return_image",val:" = True"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L531"}}),{c(){m=s("meta"),F=l(),_=s("h1"),g=s("a"),E=s("span"),v(u.$$.fragment),k=l(),Ge=s("span"),ia=o("Zero-shot Image-to-Image Translation"),kt=l(),q=s("h2"),G=s("a"),Be=s("span"),v(ee.$$.fragment),na=l(),He=s("span"),oa=o("Overview"),jt=l(),te=s("p"),ae=s("a"),ra=o("Zero-shot Image-to-Image Translation"),la=o(" by Gaurav Parmar, Krishna Kumar Singh, Richard Zhang, Yijun Li, Jingwan Lu, and Jun-Yan Zhu."),Tt=l(),we=s("p"),pa=o("The abstract of the paper is the following:"),It=l(),ye=s("p"),We=s("em"),da=o("Large-scale text-to-image generative models have shown their remarkable ability to synthesize diverse and high-quality images. However, it is still challenging to directly apply these models for editing real images for two reasons. First, it is hard for users to come up with a perfect text prompt that accurately describes every visual detail in the input image. Second, while existing models can introduce desirable changes in certain regions, they often dramatically alter the input content and introduce unexpected changes in unwanted regions. In this work, we propose pix2pix-zero, an image-to-image translation method that can preserve the content of the original image without manual prompting. We first automatically discover editing directions that reflect desired edits in the text embedding space. To preserve the general content structure after editing, we further propose cross-attention guidance, which aims to retain the cross-attention maps of the input image throughout the diffusion process. In addition, our method does not need additional training for these edits and can directly use the existing pre-trained text-to-image diffusion model. We conduct extensive experiments and show that our method outperforms existing and concurrent works for both real and synthetic image editing."),qt=l(),De=s("p"),ca=o("Resources:"),Zt=l(),j=s("ul"),$e=s("li"),se=s("a"),fa=o("Project Page"),ua=o("."),ha=l(),Se=s("li"),ie=s("a"),ma=o("Paper"),ga=o("."),_a=l(),Ee=s("li"),ne=s("a"),ba=o("Original Code"),va=o("."),Ct=l(),Z=s("h2"),B=s("a"),Re=s("span"),v(oe.$$.fragment),xa=l(),Ve=s("span"),Pa=o("Tips"),Lt=l(),S=s("ul"),$=s("li"),wa=o("The pipeline exposes two arguments namely "),Ke=s("code"),ya=o("source_embeds"),Da=o(" and "),Je=s("code"),$a=o("target_embeds"),Sa=o(`
that let you control the direction of the semantic edits in the final image to be generated. Let\u2019s say,
you wanted to translate from \u201Ccat\u201D to \u201Cdog\u201D. In this case, the edit direction will be \u201Ccat -> dog\u201D. To reflect
this in the pipeline, you simply have to set the embeddings related to the phrases including \u201Ccat\u201D to
`),Ye=s("code"),Ea=o("source_embeds"),ka=o(" and \u201Cdog\u201D to "),Qe=s("code"),ja=o("target_embeds"),Ta=o(". Refer to the code example below for more details."),Ia=l(),C=s("li"),qa=o("When you\u2019re using this pipeline from a prompt, specify the "),Xe=s("em"),Za=o("source"),Ca=o(` concept in the prompt. Taking
the above example, a valid input prompt would be: \u201Ca high resolution painting of a `),et=s("strong"),La=o("cat"),Aa=o(" in the style of van gough\u201D."),Na=l(),ke=s("li"),Ma=o("If you wanted to reverse the direction in the example above, i.e., \u201Cdog -> cat\u201D, then it\u2019s recommended to:"),re=s("ul"),L=s("li"),za=o("Swap the "),tt=s("code"),Oa=o("source_embeds"),Ua=o(" and "),at=s("code"),Fa=o("target_embeds"),Ga=o("."),Ba=l(),st=s("li"),Ha=o("Change the input prompt to include \u201Cdog\u201D."),Wa=l(),le=s("li"),Ra=o("To learn more about how the source and target embeddings are generated, refer to the "),pe=s("a"),Va=o(`original
paper`),Ka=o("."),At=l(),A=s("h2"),H=s("a"),it=s("span"),v(de.$$.fragment),Ja=l(),nt=s("span"),Ya=o("Available Pipelines:"),Nt=l(),W=s("table"),ot=s("thead"),N=s("tr"),rt=s("th"),Qa=o("Pipeline"),Xa=l(),lt=s("th"),es=o("Tasks"),ts=l(),je=s("th"),as=o("Demo"),ss=l(),pt=s("tbody"),M=s("tr"),dt=s("td"),ce=s("a"),is=o("StableDiffusionPix2PixZeroPipeline"),ns=l(),ct=s("td"),ft=s("em"),os=o("Text-Based Image Editing"),rs=l(),Te=s("td"),ls=o("[\u{1F917} Space] (soon)"),Mt=l(),z=s("h2"),R=s("a"),ut=s("span"),v(fe.$$.fragment),ps=l(),ht=s("span"),ds=o("Usage example"),zt=l(),Ie=s("p"),mt=s("strong"),cs=o("Based on an image generated with the input prompt"),Ot=l(),v(ue.$$.fragment),Ut=l(),qe=s("p"),gt=s("strong"),fs=o("Based on an input image"),Ft=l(),Ze=s("p"),_t=s("em"),us=o("Coming soon"),Gt=l(),O=s("h2"),V=s("a"),bt=s("span"),v(he.$$.fragment),hs=l(),vt=s("span"),ms=o("StableDiffusionPix2PixZeroPipeline"),Bt=l(),h=s("div"),v(me.$$.fragment),gs=l(),xt=s("p"),_s=o("Pipeline for pixel-levl image editing using Pix2Pix Zero. Based on Stable Diffusion."),bs=l(),ge=s("p"),vs=o("This model inherits from "),Ce=s("a"),xs=o("DiffusionPipeline"),Ps=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ws=l(),T=s("div"),v(_e.$$.fragment),ys=l(),Pt=s("p"),Ds=o("Function invoked when calling the pipeline for generation."),$s=l(),v(K.$$.fragment),Ss=l(),J=s("div"),v(be.$$.fragment),Es=l(),wt=s("p"),ks=o("Constructs the edit direction to steer the image generation process semantically."),js=l(),Y=s("div"),v(ve.$$.fragment),Ts=l(),U=s("p"),Is=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),yt=s("code"),qs=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Zs=o("forward"),Dt=s("code"),Cs=o("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Ls=o("enable_model_cpu_offload`, but performance is lower."),As=l(),Q=s("div"),v(xe.$$.fragment),Ns=l(),$t=s("p"),Ms=o("Generates caption for a given image."),this.h()},l(t){const c=Xi('[data-svelte="svelte-1phssyn"]',document.head);m=i(c,"META",{name:!0,content:!0}),c.forEach(a),F=p(t),_=i(t,"H1",{class:!0});var Pe=n(_);g=i(Pe,"A",{id:!0,class:!0,href:!0});var Bs=n(g);E=i(Bs,"SPAN",{});var Hs=n(E);x(u.$$.fragment,Hs),Hs.forEach(a),Bs.forEach(a),k=p(Pe),Ge=i(Pe,"SPAN",{});var Ws=n(Ge);ia=r(Ws,"Zero-shot Image-to-Image Translation"),Ws.forEach(a),Pe.forEach(a),kt=p(t),q=i(t,"H2",{class:!0});var Wt=n(q);G=i(Wt,"A",{id:!0,class:!0,href:!0});var Rs=n(G);Be=i(Rs,"SPAN",{});var Vs=n(Be);x(ee.$$.fragment,Vs),Vs.forEach(a),Rs.forEach(a),na=p(Wt),He=i(Wt,"SPAN",{});var Ks=n(He);oa=r(Ks,"Overview"),Ks.forEach(a),Wt.forEach(a),jt=p(t),te=i(t,"P",{});var zs=n(te);ae=i(zs,"A",{href:!0,rel:!0});var Js=n(ae);ra=r(Js,"Zero-shot Image-to-Image Translation"),Js.forEach(a),la=r(zs," by Gaurav Parmar, Krishna Kumar Singh, Richard Zhang, Yijun Li, Jingwan Lu, and Jun-Yan Zhu."),zs.forEach(a),Tt=p(t),we=i(t,"P",{});var Ys=n(we);pa=r(Ys,"The abstract of the paper is the following:"),Ys.forEach(a),It=p(t),ye=i(t,"P",{});var Qs=n(ye);We=i(Qs,"EM",{});var Xs=n(We);da=r(Xs,"Large-scale text-to-image generative models have shown their remarkable ability to synthesize diverse and high-quality images. However, it is still challenging to directly apply these models for editing real images for two reasons. First, it is hard for users to come up with a perfect text prompt that accurately describes every visual detail in the input image. Second, while existing models can introduce desirable changes in certain regions, they often dramatically alter the input content and introduce unexpected changes in unwanted regions. In this work, we propose pix2pix-zero, an image-to-image translation method that can preserve the content of the original image without manual prompting. We first automatically discover editing directions that reflect desired edits in the text embedding space. To preserve the general content structure after editing, we further propose cross-attention guidance, which aims to retain the cross-attention maps of the input image throughout the diffusion process. In addition, our method does not need additional training for these edits and can directly use the existing pre-trained text-to-image diffusion model. We conduct extensive experiments and show that our method outperforms existing and concurrent works for both real and synthetic image editing."),Xs.forEach(a),Qs.forEach(a),qt=p(t),De=i(t,"P",{});var ei=n(De);ca=r(ei,"Resources:"),ei.forEach(a),Zt=p(t),j=i(t,"UL",{});var Le=n(j);$e=i(Le,"LI",{});var Os=n($e);se=i(Os,"A",{href:!0,rel:!0});var ti=n(se);fa=r(ti,"Project Page"),ti.forEach(a),ua=r(Os,"."),Os.forEach(a),ha=p(Le),Se=i(Le,"LI",{});var Us=n(Se);ie=i(Us,"A",{href:!0,rel:!0});var ai=n(ie);ma=r(ai,"Paper"),ai.forEach(a),ga=r(Us,"."),Us.forEach(a),_a=p(Le),Ee=i(Le,"LI",{});var Fs=n(Ee);ne=i(Fs,"A",{href:!0,rel:!0});var si=n(ne);ba=r(si,"Original Code"),si.forEach(a),va=r(Fs,"."),Fs.forEach(a),Le.forEach(a),Ct=p(t),Z=i(t,"H2",{class:!0});var Rt=n(Z);B=i(Rt,"A",{id:!0,class:!0,href:!0});var ii=n(B);Re=i(ii,"SPAN",{});var ni=n(Re);x(oe.$$.fragment,ni),ni.forEach(a),ii.forEach(a),xa=p(Rt),Ve=i(Rt,"SPAN",{});var oi=n(Ve);Pa=r(oi,"Tips"),oi.forEach(a),Rt.forEach(a),Lt=p(t),S=i(t,"UL",{});var X=n(S);$=i(X,"LI",{});var I=n($);wa=r(I,"The pipeline exposes two arguments namely "),Ke=i(I,"CODE",{});var ri=n(Ke);ya=r(ri,"source_embeds"),ri.forEach(a),Da=r(I," and "),Je=i(I,"CODE",{});var li=n(Je);$a=r(li,"target_embeds"),li.forEach(a),Sa=r(I,`
that let you control the direction of the semantic edits in the final image to be generated. Let\u2019s say,
you wanted to translate from \u201Ccat\u201D to \u201Cdog\u201D. In this case, the edit direction will be \u201Ccat -> dog\u201D. To reflect
this in the pipeline, you simply have to set the embeddings related to the phrases including \u201Ccat\u201D to
`),Ye=i(I,"CODE",{});var pi=n(Ye);Ea=r(pi,"source_embeds"),pi.forEach(a),ka=r(I," and \u201Cdog\u201D to "),Qe=i(I,"CODE",{});var di=n(Qe);ja=r(di,"target_embeds"),di.forEach(a),Ta=r(I,". Refer to the code example below for more details."),I.forEach(a),Ia=p(X),C=i(X,"LI",{});var Ae=n(C);qa=r(Ae,"When you\u2019re using this pipeline from a prompt, specify the "),Xe=i(Ae,"EM",{});var ci=n(Xe);Za=r(ci,"source"),ci.forEach(a),Ca=r(Ae,` concept in the prompt. Taking
the above example, a valid input prompt would be: \u201Ca high resolution painting of a `),et=i(Ae,"STRONG",{});var fi=n(et);La=r(fi,"cat"),fi.forEach(a),Aa=r(Ae," in the style of van gough\u201D."),Ae.forEach(a),Na=p(X),ke=i(X,"LI",{});var Gs=n(ke);Ma=r(Gs,"If you wanted to reverse the direction in the example above, i.e., \u201Cdog -> cat\u201D, then it\u2019s recommended to:"),re=i(Gs,"UL",{});var Vt=n(re);L=i(Vt,"LI",{});var Ne=n(L);za=r(Ne,"Swap the "),tt=i(Ne,"CODE",{});var ui=n(tt);Oa=r(ui,"source_embeds"),ui.forEach(a),Ua=r(Ne," and "),at=i(Ne,"CODE",{});var hi=n(at);Fa=r(hi,"target_embeds"),hi.forEach(a),Ga=r(Ne,"."),Ne.forEach(a),Ba=p(Vt),st=i(Vt,"LI",{});var mi=n(st);Ha=r(mi,"Change the input prompt to include \u201Cdog\u201D."),mi.forEach(a),Vt.forEach(a),Gs.forEach(a),Wa=p(X),le=i(X,"LI",{});var Kt=n(le);Ra=r(Kt,"To learn more about how the source and target embeddings are generated, refer to the "),pe=i(Kt,"A",{href:!0,rel:!0});var gi=n(pe);Va=r(gi,`original
paper`),gi.forEach(a),Ka=r(Kt,"."),Kt.forEach(a),X.forEach(a),At=p(t),A=i(t,"H2",{class:!0});var Jt=n(A);H=i(Jt,"A",{id:!0,class:!0,href:!0});var _i=n(H);it=i(_i,"SPAN",{});var bi=n(it);x(de.$$.fragment,bi),bi.forEach(a),_i.forEach(a),Ja=p(Jt),nt=i(Jt,"SPAN",{});var vi=n(nt);Ya=r(vi,"Available Pipelines:"),vi.forEach(a),Jt.forEach(a),Nt=p(t),W=i(t,"TABLE",{});var Yt=n(W);ot=i(Yt,"THEAD",{});var xi=n(ot);N=i(xi,"TR",{});var Me=n(N);rt=i(Me,"TH",{});var Pi=n(rt);Qa=r(Pi,"Pipeline"),Pi.forEach(a),Xa=p(Me),lt=i(Me,"TH",{});var wi=n(lt);es=r(wi,"Tasks"),wi.forEach(a),ts=p(Me),je=i(Me,"TH",{align:!0});var yi=n(je);as=r(yi,"Demo"),yi.forEach(a),Me.forEach(a),xi.forEach(a),ss=p(Yt),pt=i(Yt,"TBODY",{});var Di=n(pt);M=i(Di,"TR",{});var ze=n(M);dt=i(ze,"TD",{});var $i=n(dt);ce=i($i,"A",{href:!0,rel:!0});var Si=n(ce);is=r(Si,"StableDiffusionPix2PixZeroPipeline"),Si.forEach(a),$i.forEach(a),ns=p(ze),ct=i(ze,"TD",{});var Ei=n(ct);ft=i(Ei,"EM",{});var ki=n(ft);os=r(ki,"Text-Based Image Editing"),ki.forEach(a),Ei.forEach(a),rs=p(ze),Te=i(ze,"TD",{align:!0});var ji=n(Te);ls=r(ji,"[\u{1F917} Space] (soon)"),ji.forEach(a),ze.forEach(a),Di.forEach(a),Yt.forEach(a),Mt=p(t),z=i(t,"H2",{class:!0});var Qt=n(z);R=i(Qt,"A",{id:!0,class:!0,href:!0});var Ti=n(R);ut=i(Ti,"SPAN",{});var Ii=n(ut);x(fe.$$.fragment,Ii),Ii.forEach(a),Ti.forEach(a),ps=p(Qt),ht=i(Qt,"SPAN",{});var qi=n(ht);ds=r(qi,"Usage example"),qi.forEach(a),Qt.forEach(a),zt=p(t),Ie=i(t,"P",{});var Zi=n(Ie);mt=i(Zi,"STRONG",{});var Ci=n(mt);cs=r(Ci,"Based on an image generated with the input prompt"),Ci.forEach(a),Zi.forEach(a),Ot=p(t),x(ue.$$.fragment,t),Ut=p(t),qe=i(t,"P",{});var Li=n(qe);gt=i(Li,"STRONG",{});var Ai=n(gt);fs=r(Ai,"Based on an input image"),Ai.forEach(a),Li.forEach(a),Ft=p(t),Ze=i(t,"P",{});var Ni=n(Ze);_t=i(Ni,"EM",{});var Mi=n(_t);us=r(Mi,"Coming soon"),Mi.forEach(a),Ni.forEach(a),Gt=p(t),O=i(t,"H2",{class:!0});var Xt=n(O);V=i(Xt,"A",{id:!0,class:!0,href:!0});var zi=n(V);bt=i(zi,"SPAN",{});var Oi=n(bt);x(he.$$.fragment,Oi),Oi.forEach(a),zi.forEach(a),hs=p(Xt),vt=i(Xt,"SPAN",{});var Ui=n(vt);ms=r(Ui,"StableDiffusionPix2PixZeroPipeline"),Ui.forEach(a),Xt.forEach(a),Bt=p(t),h=i(t,"DIV",{class:!0});var b=n(h);x(me.$$.fragment,b),gs=p(b),xt=i(b,"P",{});var Fi=n(xt);_s=r(Fi,"Pipeline for pixel-levl image editing using Pix2Pix Zero. Based on Stable Diffusion."),Fi.forEach(a),bs=p(b),ge=i(b,"P",{});var ea=n(ge);vs=r(ea,"This model inherits from "),Ce=i(ea,"A",{href:!0});var Gi=n(Ce);xs=r(Gi,"DiffusionPipeline"),Gi.forEach(a),Ps=r(ea,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ea.forEach(a),ws=p(b),T=i(b,"DIV",{class:!0});var Oe=n(T);x(_e.$$.fragment,Oe),ys=p(Oe),Pt=i(Oe,"P",{});var Bi=n(Pt);Ds=r(Bi,"Function invoked when calling the pipeline for generation."),Bi.forEach(a),$s=p(Oe),x(K.$$.fragment,Oe),Oe.forEach(a),Ss=p(b),J=i(b,"DIV",{class:!0});var ta=n(J);x(be.$$.fragment,ta),Es=p(ta),wt=i(ta,"P",{});var Hi=n(wt);ks=r(Hi,"Constructs the edit direction to steer the image generation process semantically."),Hi.forEach(a),ta.forEach(a),js=p(b),Y=i(b,"DIV",{class:!0});var aa=n(Y);x(ve.$$.fragment,aa),Ts=p(aa),U=i(aa,"P",{});var Ue=n(U);Is=r(Ue,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),yt=i(Ue,"CODE",{});var Wi=n(yt);qs=r(Wi,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Wi.forEach(a),Zs=r(Ue,"forward"),Dt=i(Ue,"CODE",{});var Ri=n(Dt);Cs=r(Ri,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Ri.forEach(a),Ls=r(Ue,"enable_model_cpu_offload`, but performance is lower."),Ue.forEach(a),aa.forEach(a),As=p(b),Q=i(b,"DIV",{class:!0});var sa=n(Q);x(xe.$$.fragment,sa),Ns=p(sa),$t=i(sa,"P",{});var Vi=n($t);Ms=r(Vi,"Generates caption for a given image."),Vi.forEach(a),sa.forEach(a),b.forEach(a),this.h()},h(){d(m,"name","hf:doc:metadata"),d(m,"content",JSON.stringify(on)),d(g,"id","zeroshot-imagetoimage-translation"),d(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(g,"href","#zeroshot-imagetoimage-translation"),d(_,"class","relative group"),d(G,"id","overview"),d(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(G,"href","#overview"),d(q,"class","relative group"),d(ae,"href","https://arxiv.org/abs/2302.03027"),d(ae,"rel","nofollow"),d(se,"href","https://pix2pixzero.github.io/"),d(se,"rel","nofollow"),d(ie,"href","https://arxiv.org/abs/2302.03027"),d(ie,"rel","nofollow"),d(ne,"href","https://github.com/pix2pixzero/pix2pix-zero"),d(ne,"rel","nofollow"),d(B,"id","tips"),d(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(B,"href","#tips"),d(Z,"class","relative group"),d(pe,"href","https://arxiv.org/abs/2302.03027"),d(pe,"rel","nofollow"),d(H,"id","available-pipelines"),d(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(H,"href","#available-pipelines"),d(A,"class","relative group"),d(je,"align","center"),d(ce,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py"),d(ce,"rel","nofollow"),d(Te,"align","center"),d(R,"id","usage-example"),d(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(R,"href","#usage-example"),d(z,"class","relative group"),d(V,"id","diffusers.StableDiffusionPix2PixZeroPipeline"),d(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(V,"href","#diffusers.StableDiffusionPix2PixZeroPipeline"),d(O,"class","relative group"),d(Ce,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),d(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,c){e(document.head,m),f(t,F,c),f(t,_,c),e(_,g),e(g,E),P(u,E,null),e(_,k),e(_,Ge),e(Ge,ia),f(t,kt,c),f(t,q,c),e(q,G),e(G,Be),P(ee,Be,null),e(q,na),e(q,He),e(He,oa),f(t,jt,c),f(t,te,c),e(te,ae),e(ae,ra),e(te,la),f(t,Tt,c),f(t,we,c),e(we,pa),f(t,It,c),f(t,ye,c),e(ye,We),e(We,da),f(t,qt,c),f(t,De,c),e(De,ca),f(t,Zt,c),f(t,j,c),e(j,$e),e($e,se),e(se,fa),e($e,ua),e(j,ha),e(j,Se),e(Se,ie),e(ie,ma),e(Se,ga),e(j,_a),e(j,Ee),e(Ee,ne),e(ne,ba),e(Ee,va),f(t,Ct,c),f(t,Z,c),e(Z,B),e(B,Re),P(oe,Re,null),e(Z,xa),e(Z,Ve),e(Ve,Pa),f(t,Lt,c),f(t,S,c),e(S,$),e($,wa),e($,Ke),e(Ke,ya),e($,Da),e($,Je),e(Je,$a),e($,Sa),e($,Ye),e(Ye,Ea),e($,ka),e($,Qe),e(Qe,ja),e($,Ta),e(S,Ia),e(S,C),e(C,qa),e(C,Xe),e(Xe,Za),e(C,Ca),e(C,et),e(et,La),e(C,Aa),e(S,Na),e(S,ke),e(ke,Ma),e(ke,re),e(re,L),e(L,za),e(L,tt),e(tt,Oa),e(L,Ua),e(L,at),e(at,Fa),e(L,Ga),e(re,Ba),e(re,st),e(st,Ha),e(S,Wa),e(S,le),e(le,Ra),e(le,pe),e(pe,Va),e(le,Ka),f(t,At,c),f(t,A,c),e(A,H),e(H,it),P(de,it,null),e(A,Ja),e(A,nt),e(nt,Ya),f(t,Nt,c),f(t,W,c),e(W,ot),e(ot,N),e(N,rt),e(rt,Qa),e(N,Xa),e(N,lt),e(lt,es),e(N,ts),e(N,je),e(je,as),e(W,ss),e(W,pt),e(pt,M),e(M,dt),e(dt,ce),e(ce,is),e(M,ns),e(M,ct),e(ct,ft),e(ft,os),e(M,rs),e(M,Te),e(Te,ls),f(t,Mt,c),f(t,z,c),e(z,R),e(R,ut),P(fe,ut,null),e(z,ps),e(z,ht),e(ht,ds),f(t,zt,c),f(t,Ie,c),e(Ie,mt),e(mt,cs),f(t,Ot,c),P(ue,t,c),f(t,Ut,c),f(t,qe,c),e(qe,gt),e(gt,fs),f(t,Ft,c),f(t,Ze,c),e(Ze,_t),e(_t,us),f(t,Gt,c),f(t,O,c),e(O,V),e(V,bt),P(he,bt,null),e(O,hs),e(O,vt),e(vt,ms),f(t,Bt,c),f(t,h,c),P(me,h,null),e(h,gs),e(h,xt),e(xt,_s),e(h,bs),e(h,ge),e(ge,vs),e(ge,Ce),e(Ce,xs),e(ge,Ps),e(h,ws),e(h,T),P(_e,T,null),e(T,ys),e(T,Pt),e(Pt,Ds),e(T,$s),P(K,T,null),e(h,Ss),e(h,J),P(be,J,null),e(J,Es),e(J,wt),e(wt,ks),e(h,js),e(h,Y),P(ve,Y,null),e(Y,Ts),e(Y,U),e(U,Is),e(U,yt),e(yt,qs),e(U,Zs),e(U,Dt),e(Dt,Cs),e(U,Ls),e(h,As),e(h,Q),P(xe,Q,null),e(Q,Ns),e(Q,$t),e($t,Ms),Ht=!0},p(t,[c]){const Pe={};c&2&&(Pe.$$scope={dirty:c,ctx:t}),K.$set(Pe)},i(t){Ht||(w(u.$$.fragment,t),w(ee.$$.fragment,t),w(oe.$$.fragment,t),w(de.$$.fragment,t),w(fe.$$.fragment,t),w(ue.$$.fragment,t),w(he.$$.fragment,t),w(me.$$.fragment,t),w(_e.$$.fragment,t),w(K.$$.fragment,t),w(be.$$.fragment,t),w(ve.$$.fragment,t),w(xe.$$.fragment,t),Ht=!0)},o(t){y(u.$$.fragment,t),y(ee.$$.fragment,t),y(oe.$$.fragment,t),y(de.$$.fragment,t),y(fe.$$.fragment,t),y(ue.$$.fragment,t),y(he.$$.fragment,t),y(me.$$.fragment,t),y(_e.$$.fragment,t),y(K.$$.fragment,t),y(be.$$.fragment,t),y(ve.$$.fragment,t),y(xe.$$.fragment,t),Ht=!1},d(t){a(m),t&&a(F),t&&a(_),D(u),t&&a(kt),t&&a(q),D(ee),t&&a(jt),t&&a(te),t&&a(Tt),t&&a(we),t&&a(It),t&&a(ye),t&&a(qt),t&&a(De),t&&a(Zt),t&&a(j),t&&a(Ct),t&&a(Z),D(oe),t&&a(Lt),t&&a(S),t&&a(At),t&&a(A),D(de),t&&a(Nt),t&&a(W),t&&a(Mt),t&&a(z),D(fe),t&&a(zt),t&&a(Ie),t&&a(Ot),D(ue,t),t&&a(Ut),t&&a(qe),t&&a(Ft),t&&a(Ze),t&&a(Gt),t&&a(O),D(he),t&&a(Bt),t&&a(h),D(me),D(_e),D(K),D(be),D(ve),D(xe)}}}const on={local:"zeroshot-imagetoimage-translation",sections:[{local:"overview",title:"Overview"},{local:"tips",title:"Tips "},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"diffusers.StableDiffusionPix2PixZeroPipeline",title:"StableDiffusionPix2PixZeroPipeline"}],title:"Zero-shot Image-to-Image Translation"};function rn(Et){return en(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class un extends Ji{constructor(m){super();Yi(this,m,rn,nn,Qi,{})}}export{un as default,on as metadata};
